xref: /freebsd/libexec/rc/rc.subr (revision a3557ef0)
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2# $FreeBSD$
3#
4# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5# All rights reserved.
6#
7# This code is derived from software contributed to The NetBSD Foundation
8# by Luke Mewburn.
9#
10# Redistribution and use in source and binary forms, with or without
11# modification, are permitted provided that the following conditions
12# are met:
13# 1. Redistributions of source code must retain the above copyright
14#    notice, this list of conditions and the following disclaimer.
15# 2. Redistributions in binary form must reproduce the above copyright
16#    notice, this list of conditions and the following disclaimer in the
17#    documentation and/or other materials provided with the distribution.
18#
19# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29# POSSIBILITY OF SUCH DAMAGE.
30#
31# rc.subr
32#	functions used by various rc scripts
33#
34
35: ${RC_PID:=$$}; export RC_PID
36
37#
38#	Operating System dependent/independent variables
39#
40
41if [ -n "${_rc_subr_loaded}" ]; then
42	return
43fi
44
45_rc_subr_loaded="YES"
46
47SYSCTL="/sbin/sysctl"
48SYSCTL_N="${SYSCTL} -n"
49SYSCTL_W="${SYSCTL}"
50PROTECT="/usr/bin/protect"
51ID="/usr/bin/id"
52IDCMD="if [ -x $ID ]; then $ID -un; fi"
53PS="/bin/ps -ww"
54JID=0
55# rc_service provides the path to the service script that we are executing.
56# This is not being set here in an execution context, necessarily, so it's
57# really just a reasonable guess, and it will get overwritten later if
58# we are executing from some other means than direct execution by service(8)
59# or manual invocation of the service script.  The prime example of this is
60# during system startup, all rc scripts will be invoked via /etc/rc, so
61# run_rc_script will overwrite rc_service with the file being sourced.
62rc_service="$0"
63
64#
65#	functions
66#	---------
67
68# list_vars pattern
69#	List variables matching glob pattern.
70#
71list_vars()
72{
73	# Localize 'set' option below.
74	local -
75	local IFS=$'\n' line varname
76
77	# Disable path expansion in unquoted 'for' parameters below.
78	set -o noglob
79
80	for line in $(set); do
81		varname="${line%%=*}"
82
83		case "$varname" in
84		"$line"|*[!a-zA-Z0-9_]*)
85			continue
86			;;
87		$1)
88			echo $varname
89			;;
90		esac
91	done
92}
93
94# set_rcvar [var] [defval] [desc]
95#
96#	Echo or define a rc.conf(5) variable name.  Global variable
97#	$rcvars is used.
98#
99#	If no argument is specified, echo "${name}_enable".
100#
101#	If only a var is specified, echo "${var}_enable".
102#
103#	If var and defval are specified, the ${var} is defined as
104#	rc.conf(5) variable and the default value is ${defvar}.  An
105#	optional argument $desc can also be specified to add a
106#	description for that.
107#
108set_rcvar()
109{
110	local _var
111
112	case $# in
113	0)	echo ${name}_enable ;;
114	1)	echo ${1}_enable ;;
115	*)
116		debug "set_rcvar: \$$1=$2 is added" \
117		    " as a rc.conf(5) variable."
118		_var=$1
119		rcvars="${rcvars# } $_var"
120		eval ${_var}_defval=\"$2\"
121		shift 2
122		eval ${_var}_desc=\"$*\"
123	;;
124	esac
125}
126
127# set_rcvar_obsolete oldvar [newvar] [msg]
128#	Define obsolete variable.
129#	Global variable $rcvars_obsolete is used.
130#
131set_rcvar_obsolete()
132{
133	local _var
134	_var=$1
135	debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
136
137	rcvars_obsolete="${rcvars_obsolete# } $1"
138	eval ${1}_newvar=\"$2\"
139	shift 2
140	eval ${_var}_obsolete_msg=\"$*\"
141}
142
143#
144# force_depend script [rcvar]
145#	Force a service to start. Intended for use by services
146#	to resolve dependency issues.
147#	$1 - filename of script, in /etc/rc.d, to run
148#	$2 - name of the script's rcvar (minus the _enable)
149#
150force_depend()
151{
152	local _depend _dep_rcvar
153
154	_depend="$1"
155	_dep_rcvar="${2:-$1}_enable"
156
157	[ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
158	    checkyesno $_dep_rcvar && return 0
159
160	/etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
161
162	info "${name} depends on ${_depend}, which will be forced to start."
163	if ! /etc/rc.d/${_depend} forcestart; then
164		warn "Unable to force ${_depend}. It may already be running."
165		return 1
166	fi
167}
168
169#
170# checkyesno var
171#	Test $1 variable, and warn if not set to YES or NO.
172#	Return 0 if it's "yes" (et al), nonzero otherwise.
173#
174checkyesno()
175{
176	eval _value=\$${1}
177	debug "checkyesno: $1 is set to $_value."
178	case $_value in
179
180		#	"yes", "true", "on", or "1"
181	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
182		return 0
183		;;
184
185		#	"no", "false", "off", or "0"
186	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
187		return 1
188		;;
189	*)
190		warn "\$${1} is not set properly - see rc.conf(5)."
191		return 1
192		;;
193	esac
194}
195
196#
197# reverse_list list
198#	print the list in reverse order
199#
200reverse_list()
201{
202	_revlist=
203	for _revfile; do
204		_revlist="$_revfile $_revlist"
205	done
206	echo $_revlist
207}
208
209# stop_boot always
210#	If booting directly to multiuser or $always is enabled,
211#	send SIGTERM to the parent (/etc/rc) to abort the boot.
212#	Otherwise just exit.
213#
214stop_boot()
215{
216	local always
217
218	case $1 in
219		#	"yes", "true", "on", or "1"
220        [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
221		always=true
222		;;
223	*)
224		always=false
225		;;
226	esac
227	if [ "$autoboot" = yes -o "$always" = true ]; then
228		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
229		kill -TERM ${RC_PID}
230	fi
231	exit 1
232}
233
234#
235# mount_critical_filesystems type
236#	Go through the list of critical filesystems as provided in
237#	the rc.conf(5) variable $critical_filesystems_${type}, checking
238#	each one to see if it is mounted, and if it is not, mounting it.
239#
240mount_critical_filesystems()
241{
242	eval _fslist=\$critical_filesystems_${1}
243	for _fs in $_fslist; do
244		mount | (
245			_ismounted=false
246			while read what _on on _type type; do
247				if [ $on = $_fs ]; then
248					_ismounted=true
249				fi
250			done
251			if $_ismounted; then
252				:
253			else
254				mount $_fs >/dev/null 2>&1
255			fi
256		)
257	done
258}
259
260#
261# check_pidfile pidfile procname [interpreter]
262#	Parses the first line of pidfile for a PID, and ensures
263#	that the process is running and matches procname.
264#	Prints the matching PID upon success, nothing otherwise.
265#	interpreter is optional; see _find_processes() for details.
266#
267check_pidfile()
268{
269	_pidfile=$1
270	_procname=$2
271	_interpreter=$3
272	if [ -z "$_pidfile" -o -z "$_procname" ]; then
273		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
274	fi
275	if [ ! -f $_pidfile ]; then
276		debug "pid file ($_pidfile): not readable."
277		return
278	fi
279	read _pid _junk < $_pidfile
280	if [ -z "$_pid" ]; then
281		debug "pid file ($_pidfile): no pid in file."
282		return
283	fi
284	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
285}
286
287#
288# check_process procname [interpreter]
289#	Ensures that a process (or processes) named procname is running.
290#	Prints a list of matching PIDs.
291#	interpreter is optional; see _find_processes() for details.
292#
293check_process()
294{
295	_procname=$1
296	_interpreter=$2
297	if [ -z "$_procname" ]; then
298		err 3 'USAGE: check_process procname [interpreter]'
299	fi
300	_find_processes $_procname ${_interpreter:-.} '-ax'
301}
302
303#
304# _find_processes procname interpreter psargs
305#	Search for procname in the output of ps generated by psargs.
306#	Prints the PIDs of any matching processes, space separated.
307#
308#	If interpreter == ".", check the following variations of procname
309#	against the first word of each command:
310#		procname
311#		`basename procname`
312#		`basename procname` + ":"
313#		"(" + `basename procname` + ")"
314#		"[" + `basename procname` + "]"
315#
316#	If interpreter != ".", read the first line of procname, remove the
317#	leading #!, normalise whitespace, append procname, and attempt to
318#	match that against each command, either as is, or with extra words
319#	at the end.  As an alternative, to deal with interpreted daemons
320#	using perl, the basename of the interpreter plus a colon is also
321#	tried as the prefix to procname.
322#
323_find_processes()
324{
325	if [ $# -ne 3 ]; then
326		err 3 'USAGE: _find_processes procname interpreter psargs'
327	fi
328	_procname=$1
329	_interpreter=$2
330	_psargs=$3
331
332	_pref=
333	if [ $_interpreter != "." ]; then	# an interpreted script
334		_script="${_chroot}${_chroot:+/}$_procname"
335		if [ -r "$_script" ]; then
336			read _interp < $_script	# read interpreter name
337			case "$_interp" in
338			\#!*)
339				_interp=${_interp#\#!}	# strip #!
340				set -- $_interp
341				case $1 in
342				*/bin/env)
343					shift	# drop env to get real name
344					;;
345				esac
346				if [ $_interpreter != $1 ]; then
347					warn "\$command_interpreter $_interpreter != $1"
348				fi
349				;;
350			*)
351				warn "no shebang line in $_script"
352				set -- $_interpreter
353				;;
354			esac
355		else
356			warn "cannot read shebang line from $_script"
357			set -- $_interpreter
358		fi
359		_interp="$* $_procname"		# cleanup spaces, add _procname
360		_interpbn=${1##*/}
361		_fp_args='_argv'
362		_fp_match='case "$_argv" in
363		    ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
364	else					# a normal daemon
365		_procnamebn=${_procname##*/}
366		_fp_args='_arg0 _argv'
367		_fp_match='case "$_arg0" in
368		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
369	fi
370
371	_proccheck="\
372		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
373		while read _npid _jid '"$_fp_args"'; do
374			'"$_fp_match"'
375				if [ "$JID" -eq "$_jid" ];
376				then echo -n "$_pref$_npid";
377				_pref=" ";
378				fi
379				;;
380			esac
381		done'
382
383#	debug "in _find_processes: proccheck is ($_proccheck)."
384	eval $_proccheck
385}
386
387# sort_lite [-b] [-n] [-k POS] [-t SEP]
388#	A lite version of sort(1) (supporting a few options) that can be used
389#	before the real sort(1) is available (e.g., in scripts that run prior
390#	to mountcritremote). Requires only shell built-in functionality.
391#
392sort_lite()
393{
394	local funcname=sort_lite
395	local sort_sep="$IFS" sort_ignore_leading_space=
396	local sort_field=0 sort_strict_fields= sort_numeric=
397	local nitems=0 skip_leading=0 trim=
398
399	local OPTIND flag
400	while getopts bnk:t: flag; do
401		case "$flag" in
402		b) sort_ignore_leading_space=1 ;;
403		n) sort_numeric=1 sort_ignore_leading_space=1 ;;
404		k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
405			# NB: Unlike sort(1) only one POS allowed
406		t) sort_sep="$OPTARG"
407		   if [ ${#sort_sep} -gt 1 ]; then
408		   	echo "$funcname: multi-character tab \`$sort_sep'" >&2
409		   	return 1
410		   fi
411		   sort_strict_fields=1
412		   ;;
413		\?) return 1 ;;
414		esac
415	done
416	shift $(( $OPTIND - 1 ))
417
418	# Create transformation pattern to trim leading text if desired
419	case "$sort_field" in
420	""|[!0-9]*|*[!0-9.]*)
421		echo "$funcname: invalid sort field \`$sort_field'" >&2
422		return 1
423		;;
424	*.*)
425		skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
426		while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
427			trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
428		done
429	esac
430
431	# Copy input to series of local numbered variables
432	# NB: IFS of NULL preserves leading whitespace
433	local LINE
434	while IFS= read -r LINE || [ "$LINE" ]; do
435		nitems=$(( $nitems + 1 ))
436		local src_$nitems="$LINE"
437	done
438
439	#
440	# Sort numbered locals using insertion sort
441	#
442	local curitem curitem_orig curitem_mod curitem_haskey
443	local dest dest_orig dest_mod dest_haskey
444	local d gt n
445	local i=1
446	while [ $i -le $nitems ]; do
447		curitem_haskey=1 # Assume sort field (-k POS) exists
448		eval curitem=\"\$src_$i\"
449		curitem_mod="$curitem" # for modified comparison
450		curitem_orig="$curitem" # for original comparison
451
452		# Trim leading whitespace if desired
453		if [ "$sort_ignore_leading_space" ]; then
454			while case "$curitem_orig" in
455				[$IFS]*) : ;; *) false; esac
456			do
457				curitem_orig="${curitem_orig#?}"
458			done
459			curitem_mod="$curitem_orig"
460		fi
461
462		# Shift modified comparison value if sort field (-k POS) is > 1
463		n=$sort_field
464		while [ $n -gt 1 ]; do
465			case "$curitem_mod" in
466			*[$sort_sep]*)
467				# Cut text up-to (and incl.) first separator
468				curitem_mod="${curitem_mod#*[$sort_sep]}"
469
470				# Skip NULLs unless strict field splitting
471				[ "$sort_strict_fields" ] ||
472					[ "${curitem_mod%%[$sort_sep]*}" ] ||
473					[ $n -eq 2 ] ||
474					continue
475				;;
476			*)
477				# Asked for a field that doesn't exist
478				curitem_haskey= break
479			esac
480			n=$(( $n - 1 ))
481		done
482
483		# Trim trailing words if sort field >= 1
484		[ $sort_field -ge 1 -a "$sort_numeric" ] &&
485			curitem_mod="${curitem_mod%%[$sort_sep]*}"
486
487		# Apply optional trim (-k POS.TRIM) to cut leading characters
488		curitem_mod="${curitem_mod#$trim}"
489
490		# Determine the type of modified comparison to use initially
491		# NB: Prefer numerical if requested but fallback to standard
492		case "$curitem_mod" in
493		""|[!0-9]*) # NULL or begins with non-number
494			gt=">"
495			[ "$sort_numeric" ] && curitem_mod=0
496			;;
497		*)
498			if [ "$sort_numeric" ]; then
499				gt="-gt"
500				curitem_mod="${curitem_mod%%[!0-9]*}"
501					# NB: trailing non-digits removed
502					# otherwise numeric comparison fails
503			else
504				gt=">"
505			fi
506		esac
507
508		# If first time through, short-circuit below position-search
509		if [ $i -le 1 ]; then
510			d=0
511		else
512			d=1
513		fi
514
515		#
516		# Find appropriate element position
517		#
518		while [ $d -gt 0 ]
519		do
520			dest_haskey=$curitem_haskey
521			eval dest=\"\$dest_$d\"
522			dest_mod="$dest" # for modified comparison
523			dest_orig="$dest" # for original comparison
524
525			# Trim leading whitespace if desired
526			if [ "$sort_ignore_leading_space" ]; then
527				while case "$dest_orig" in
528					[$IFS]*) : ;; *) false; esac
529				do
530					dest_orig="${dest_orig#?}"
531				done
532				dest_mod="$dest_orig"
533			fi
534
535			# Shift modified value if sort field (-k POS) is > 1
536			n=$sort_field
537			while [ $n -gt 1 ]; do
538				case "$dest_mod" in
539				*[$sort_sep]*)
540					# Cut text up-to (and incl.) 1st sep
541					dest_mod="${dest_mod#*[$sort_sep]}"
542
543					# Skip NULLs unless strict fields
544					[ "$sort_strict_fields" ] ||
545					    [ "${dest_mod%%[$sort_sep]*}" ] ||
546					    [ $n -eq 2 ] ||
547					    continue
548					;;
549				*)
550					# Asked for a field that doesn't exist
551					dest_haskey= break
552				esac
553				n=$(( $n - 1 ))
554			done
555
556			# Trim trailing words if sort field >= 1
557			[ $sort_field -ge 1 -a "$sort_numeric" ] &&
558				dest_mod="${dest_mod%%[$sort_sep]*}"
559
560			# Apply optional trim (-k POS.TRIM), cut leading chars
561			dest_mod="${dest_mod#$trim}"
562
563			# Determine type of modified comparison to use
564			# NB: Prefer numerical if requested, fallback to std
565			case "$dest_mod" in
566			""|[!0-9]*) # NULL or begins with non-number
567				gt=">"
568				[ "$sort_numeric" ] && dest_mod=0
569				;;
570			*)
571				if [ "$sort_numeric" ]; then
572					gt="-gt"
573					dest_mod="${dest_mod%%[!0-9]*}"
574						# NB: kill trailing non-digits
575						# for numeric comparison safety
576				else
577					gt=">"
578				fi
579			esac
580
581			# Break if we've found the proper element position
582			if [ "$curitem_haskey" -a "$dest_haskey" ]; then
583				if [ "$dest_mod" = "$curitem_mod" ]; then
584					[ "$dest_orig" ">" "$curitem_orig" ] &&
585						break
586				elif [ "$dest_mod" $gt "$curitem_mod" ] \
587					2> /dev/null
588				then
589					break
590				fi
591			else
592				[ "$dest_orig" ">" "$curitem_orig" ] && break
593			fi
594
595			# Break if we've hit the end
596			[ $d -ge $i ] && break
597
598			d=$(( $d + 1 ))
599		done
600
601		# Shift remaining positions forward, making room for new item
602		n=$i
603		while [ $n -ge $d ]; do
604			# Shift destination item forward one placement
605			eval dest_$(( $n + 1 ))=\"\$dest_$n\"
606			n=$(( $n - 1 ))
607		done
608
609		# Place the element
610		if [ $i -eq 1 ]; then
611			local dest_1="$curitem"
612		else
613			local dest_$d="$curitem"
614		fi
615
616		i=$(( $i + 1 ))
617	done
618
619	# Print sorted results
620	d=1
621	while [ $d -le $nitems ]; do
622		eval echo \"\$dest_$d\"
623		d=$(( $d + 1 ))
624	done
625}
626
627#
628# wait_for_pids pid [pid ...]
629#	spins until none of the pids exist
630#
631wait_for_pids()
632{
633	local _list _prefix _nlist _j
634
635	_list="$@"
636	if [ -z "$_list" ]; then
637		return
638	fi
639	_prefix=
640	while true; do
641		_nlist="";
642		for _j in $_list; do
643			if kill -0 $_j 2>/dev/null; then
644				_nlist="${_nlist}${_nlist:+ }$_j"
645				[ -n "$_prefix" ] && sleep 1
646			fi
647		done
648		if [ -z "$_nlist" ]; then
649			break
650		fi
651		_list=$_nlist
652		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
653		_prefix=", "
654		pwait $_list 2>/dev/null
655	done
656	if [ -n "$_prefix" ]; then
657		echo "."
658	fi
659}
660
661#
662# get_pidfile_from_conf string file
663#
664#	Takes a string to search for in the specified file.
665#	Ignores lines with traditional comment characters.
666#
667# Example:
668#
669# if get_pidfile_from_conf string file; then
670#	pidfile="$_pidfile_from_conf"
671# else
672#	pidfile='appropriate default'
673# fi
674#
675get_pidfile_from_conf()
676{
677	if [ -z "$1" -o -z "$2" ]; then
678		err 3 "USAGE: get_pidfile_from_conf string file ($name)"
679	fi
680
681	local string file line
682
683	string="$1" ; file="$2"
684
685	if [ ! -s "$file" ]; then
686		err 3 "get_pidfile_from_conf: $file does not exist ($name)"
687	fi
688
689	while read line; do
690		case "$line" in
691		*[#\;]*${string}*)	continue ;;
692		*${string}*)		break ;;
693		esac
694	done < $file
695
696	if [ -n "$line" ]; then
697		line=${line#*/}
698		_pidfile_from_conf="/${line%%[\"\;]*}"
699	else
700		return 1
701	fi
702}
703
704#
705# check_startmsgs
706#	If rc_quiet is set (usually as a result of using faststart at
707#	boot time) check if rc_startmsgs is enabled.
708#
709check_startmsgs()
710{
711	if [ -n "$rc_quiet" ]; then
712		checkyesno rc_startmsgs
713	else
714		return 0
715	fi
716}
717
718#
719# run_rc_command argument
720#	Search for argument in the list of supported commands, which is:
721#		"start stop restart rcvar status poll ${extra_commands}"
722#	If there's a match, run ${argument}_cmd or the default method
723#	(see below).
724#
725#	If argument has a given prefix, then change the operation as follows:
726#		Prefix	Operation
727#		------	---------
728#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
729#		force	Set ${rcvar} to YES, and set rc_force=yes
730#		one	Set ${rcvar} to YES
731#		quiet	Don't output some diagnostics, and set rc_quiet=yes
732#
733#	The following globals are used:
734#
735#	Name		Needed	Purpose
736#	----		------	-------
737#	name		y	Name of script.
738#
739#	command		n	Full path to command.
740#				Not needed if ${rc_arg}_cmd is set for
741#				each keyword.
742#
743#	command_args	n	Optional args/shell directives for command.
744#
745#	command_interpreter n	If not empty, command is interpreted, so
746#				call check_{pidfile,process}() appropriately.
747#
748#	desc		n	Description of script.
749#
750#	extra_commands	n	List of extra commands supported.
751#
752#	pidfile		n	If set, use check_pidfile $pidfile $command,
753#				otherwise use check_process $command.
754#				In either case, only check if $command is set.
755#
756#	procname	n	Process name to check for instead of $command.
757#
758#	rcvar		n	This is checked with checkyesno to determine
759#				if the action should be run.
760#
761#	${name}_program	n	Full path to command.
762#				Meant to be used in /etc/rc.conf to override
763#				${command}.
764#
765#	${name}_chroot	n	Directory to chroot to before running ${command}
766#				Requires /usr to be mounted.
767#
768#	${name}_chdir	n	Directory to cd to before running ${command}
769#				(if not using ${name}_chroot).
770#
771#	${name}_flags	n	Arguments to call ${command} with.
772#				NOTE:	$flags from the parent environment
773#					can be used to override this.
774#
775#	${name}_env	n	Environment variables to run ${command} with.
776#
777#	${name}_env_file n	File to source variables to run ${command} with.
778#
779#	${name}_fib	n	Routing table number to run ${command} with.
780#
781#	${name}_nice	n	Nice level to run ${command} at.
782#
783#	${name}_oomprotect n	Don't kill ${command} when swap space is exhausted.
784#
785#	${name}_user	n	User to run ${command} as, using su(1) if not
786#				using ${name}_chroot.
787#				Requires /usr to be mounted.
788#
789#	${name}_group	n	Group to run chrooted ${command} as.
790#				Requires /usr to be mounted.
791#
792#	${name}_groups	n	Comma separated list of supplementary groups
793#				to run the chrooted ${command} with.
794#				Requires /usr to be mounted.
795#
796#	${name}_prepend	n	Command added before ${command}.
797#
798#	${name}_login_class n	Login class to use, else "daemon".
799#
800#	${name}_limits	n	limits(1) to apply to ${command}.
801#
802#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
803#				Otherwise, use default command (see below)
804#
805#	${rc_arg}_precmd n	If set, run just before performing the
806#				${rc_arg}_cmd method in the default
807#				operation (i.e, after checking for required
808#				bits and process (non)existence).
809#				If this completes with a non-zero exit code,
810#				don't run ${rc_arg}_cmd.
811#
812#	${rc_arg}_postcmd n	If set, run just after performing the
813#				${rc_arg}_cmd method, if that method
814#				returned a zero exit code.
815#
816#	required_dirs	n	If set, check for the existence of the given
817#				directories before running a (re)start command.
818#
819#	required_files	n	If set, check for the readability of the given
820#				files before running a (re)start command.
821#
822#	required_modules n	If set, ensure the given kernel modules are
823#				loaded before running a (re)start command.
824#				The check and possible loads are actually
825#				done after start_precmd so that the modules
826#				aren't loaded in vain, should the precmd
827#				return a non-zero status to indicate a error.
828#				If a word in the list looks like "foo:bar",
829#				"foo" is the KLD file name and "bar" is the
830#				module name.  If a word looks like "foo~bar",
831#				"foo" is the KLD file name and "bar" is a
832#				egrep(1) pattern matching the module name.
833#				Otherwise the module name is assumed to be
834#				the same as the KLD file name, which is most
835#				common.  See load_kld().
836#
837#	required_vars	n	If set, perform checkyesno on each of the
838#				listed variables before running the default
839#				(re)start command.
840#
841#	Default behaviour for a given argument, if no override method is
842#	provided:
843#
844#	Argument	Default behaviour
845#	--------	-----------------
846#	start		if !running && checkyesno ${rcvar}
847#				${command}
848#
849#	stop		if ${pidfile}
850#				rc_pid=$(check_pidfile $pidfile $command)
851#			else
852#				rc_pid=$(check_process $command)
853#			kill $sig_stop $rc_pid
854#			wait_for_pids $rc_pid
855#			($sig_stop defaults to TERM.)
856#
857#	reload		Similar to stop, except use $sig_reload instead,
858#			and doesn't wait_for_pids.
859#			$sig_reload defaults to HUP.
860#			Note that `reload' isn't provided by default,
861#			it should be enabled via $extra_commands.
862#
863#	restart		Run `stop' then `start'.
864#
865#	status		Show if ${command} is running, etc.
866#
867#	poll		Wait for ${command} to exit.
868#
869#	rcvar		Display what rc.conf variable is used (if any).
870#
871#	enabled		Return true if the service is enabled.
872#
873#	describe	Show the service's description
874#
875#	extracommands	Show the service's extra commands
876#
877#	Variables available to methods, and after run_rc_command() has
878#	completed:
879#
880#	Variable	Purpose
881#	--------	-------
882#	rc_arg		Argument to command, after fast/force/one processing
883#			performed
884#
885#	rc_flags	Flags to start the default command with.
886#			Defaults to ${name}_flags, unless overridden
887#			by $flags from the environment.
888#			This variable may be changed by the precmd method.
889#
890#       rc_service      Path to the service being executed, in case the service
891#                       needs to re-invoke itself.
892#
893#	rc_pid		PID of command (if appropriate)
894#
895#	rc_fast		Not empty if "fast" was provided (q.v.)
896#
897#	rc_force	Not empty if "force" was provided (q.v.)
898#
899#	rc_quiet	Not empty if "quiet" was provided
900#
901#
902run_rc_command()
903{
904	_return=0
905	rc_arg=$1
906	if [ -z "$name" ]; then
907		err 3 'run_rc_command: $name is not set.'
908	fi
909
910	# Don't repeat the first argument when passing additional command-
911	# line arguments to the command subroutines.
912	#
913	shift 1
914	rc_extra_args="$*"
915
916	_rc_prefix=
917	case "$rc_arg" in
918	fast*)				# "fast" prefix; don't check pid
919		rc_arg=${rc_arg#fast}
920		rc_fast=yes
921		rc_quiet=yes
922		;;
923	force*)				# "force" prefix; always run
924		rc_force=yes
925		_rc_prefix=force
926		rc_arg=${rc_arg#${_rc_prefix}}
927		if [ -n "${rcvar}" ]; then
928			eval ${rcvar}=YES
929		fi
930		;;
931	one*)				# "one" prefix; set ${rcvar}=yes
932		_rc_prefix=one
933		rc_arg=${rc_arg#${_rc_prefix}}
934		if [ -n "${rcvar}" ]; then
935			eval ${rcvar}=YES
936		fi
937		;;
938	quiet*)				# "quiet" prefix; omit some messages
939		_rc_prefix=quiet
940		rc_arg=${rc_arg#${_rc_prefix}}
941		rc_quiet=yes
942		;;
943	esac
944
945	eval _override_command=\$${name}_program
946	command=${_override_command:-$command}
947
948	_keywords="start stop restart rcvar enable disable delete enabled describe extracommands $extra_commands"
949	rc_pid=
950	_pidcmd=
951	_procname=${procname:-${command}}
952
953					# setup pid check command
954	if [ -n "$_procname" ]; then
955		if [ -n "$pidfile" ]; then
956			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
957		else
958			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
959		fi
960		_keywords="${_keywords} status poll"
961	fi
962
963	if [ -z "$rc_arg" ]; then
964		rc_usage $_keywords
965	fi
966
967	if [ "$rc_arg" = "enabled" ] ; then
968		checkyesno ${rcvar}
969		return $?
970	fi
971
972	if [ -n "$flags" ]; then	# allow override from environment
973		rc_flags=$flags
974	else
975		eval rc_flags=\$${name}_flags
976	fi
977	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
978	    _nice=\$${name}_nice	_user=\$${name}_user \
979	    _group=\$${name}_group	_groups=\$${name}_groups \
980	    _fib=\$${name}_fib		_env=\$${name}_env \
981	    _prepend=\$${name}_prepend	_login_class=\${${name}_login_class:-daemon} \
982	    _limits=\$${name}_limits    _oomprotect=\$${name}_oomprotect \
983	    _env_file=\$${name}_env_file
984
985	if [ -n "$_env_file" ] && [ -r "${_env_file}" ]; then	# load env from file
986		set -a
987		. $_env_file
988		set +a
989	fi
990
991	if [ -n "$_user" ]; then	# unset $_user if running as that user
992		if [ "$_user" = "$(eval $IDCMD)" ]; then
993			unset _user
994		fi
995	fi
996
997	[ -z "$autoboot" ] && eval $_pidcmd	# determine the pid if necessary
998
999	for _elem in $_keywords; do
1000		if [ "$_elem" != "$rc_arg" ]; then
1001			continue
1002		fi
1003					# if ${rcvar} is set, $1 is not "rcvar", "describe",
1004					# "enable" or "delete", and ${rc_pid} is not set, run:
1005					#	checkyesno ${rcvar}
1006					# and return if that failed
1007					#
1008		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
1009		    -a "$rc_arg" != "delete" -a "$rc_arg" != "enable" \
1010		    -a "$rc_arg" != "describe" ] ||
1011		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
1012			if ! checkyesno ${rcvar}; then
1013				if [ -n "${rc_quiet}" ]; then
1014					return 0
1015				fi
1016				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
1017				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
1018				echo "instead of '${rc_arg}'."
1019				return 0
1020			fi
1021		fi
1022
1023		if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
1024			if [ -z "$rc_quiet" ]; then
1025				echo 1>&2 "${name} already running? " \
1026				    "(pid=$rc_pid)."
1027			fi
1028			return 1
1029		fi
1030
1031					# if there's a custom ${XXX_cmd},
1032					# run that instead of the default
1033					#
1034		eval _cmd=\$${rc_arg}_cmd \
1035		     _precmd=\$${rc_arg}_precmd \
1036		     _postcmd=\$${rc_arg}_postcmd
1037
1038		if [ -n "$_cmd" ]; then
1039			if [ -n "$_env" ]; then
1040				eval "export -- $_env"
1041			fi
1042			_run_rc_precmd || return 1
1043			_run_rc_doit "$_cmd $rc_extra_args" || return 1
1044			_run_rc_postcmd
1045			return $_return
1046		fi
1047
1048		case "$rc_arg" in	# default operations...
1049
1050		describe)
1051			if [ -n "$desc" ]; then
1052				echo "$desc"
1053			fi
1054			;;
1055
1056		extracommands)
1057			echo "$extra_commands"
1058			;;
1059
1060		enable)
1061			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=YES") &&
1062				echo "$name enabled in ${_out%%:*}"
1063			;;
1064
1065		disable)
1066			_out=$(/usr/sbin/sysrc -vs "$name" "$rcvar=NO") &&
1067				echo "$name disabled in ${_out%%:*}"
1068			;;
1069
1070		delete)
1071			_files=
1072			for _file in $(sysrc -lEs "$name"); do
1073				_out=$(sysrc -Fif $_file "$rcvar") && _files="$_files $_file"
1074			done
1075			/usr/sbin/sysrc -x "$rcvar" && echo "$rcvar deleted in ${_files# }"
1076				# delete file in rc.conf.d if desired and empty.
1077			checkyesno service_delete_empty || _files=
1078			for _file in $_files; do
1079				[ "$_file" = "${_file#*/rc.conf.d/}" ] && continue
1080				[ $(/usr/bin/stat -f%z $_file) -gt 0 ] && continue
1081				/bin/rm "$_file" && echo "Empty file $_file removed"
1082			done
1083			;;
1084
1085		status)
1086			_run_rc_precmd || return 1
1087			if [ -n "$rc_pid" ]; then
1088				echo "${name} is running as pid $rc_pid."
1089			else
1090				echo "${name} is not running."
1091				return 1
1092			fi
1093			_run_rc_postcmd
1094			;;
1095
1096		start)
1097			if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1098				warn "run_rc_command: cannot run $command"
1099				return 1
1100			fi
1101
1102			if ! _run_rc_precmd; then
1103				warn "failed precmd routine for ${name}"
1104				return 1
1105			fi
1106
1107					# setup the full command to run
1108					#
1109			check_startmsgs && echo "Starting ${name}."
1110			if [ -n "$_chroot" ]; then
1111				_cd=
1112				_doit="\
1113${_nice:+nice -n $_nice }\
1114${_fib:+setfib -F $_fib }\
1115${_env:+env $_env }\
1116chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1117$_chroot $command $rc_flags $command_args"
1118			else
1119				_cd="${_chdir:+cd $_chdir && }"
1120				_doit="\
1121${_fib:+setfib -F $_fib }\
1122${_env:+env $_env }\
1123$command $rc_flags $command_args"
1124				if [ -n "$_user" ]; then
1125				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1126				fi
1127				if [ -n "$_nice" ]; then
1128					if [ -z "$_user" ]; then
1129						_doit="sh -c \"$_doit\""
1130					fi
1131					_doit="nice -n $_nice $_doit"
1132				fi
1133				if [ -n "$_prepend" ]; then
1134					_doit="$_prepend $_doit"
1135				fi
1136			fi
1137
1138					# Prepend default limits
1139			_doit="$_cd limits -C $_login_class $_limits $_doit"
1140
1141					# run the full command
1142					#
1143			if ! _run_rc_doit "$_doit"; then
1144				warn "failed to start ${name}"
1145				return 1
1146			fi
1147
1148					# finally, run postcmd
1149					#
1150			_run_rc_postcmd
1151			;;
1152
1153		stop)
1154			if [ -z "$rc_pid" ]; then
1155				[ -n "$rc_fast" ] && return 0
1156				_run_rc_notrunning
1157				return 1
1158			fi
1159
1160			_run_rc_precmd || return 1
1161
1162					# send the signal to stop
1163					#
1164			echo "Stopping ${name}."
1165			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1166			_run_rc_doit "$_doit" || return 1
1167
1168					# wait for the command to exit,
1169					# and run postcmd.
1170			wait_for_pids $rc_pid
1171
1172			_run_rc_postcmd
1173			;;
1174
1175		reload)
1176			if [ -z "$rc_pid" ]; then
1177				_run_rc_notrunning
1178				return 1
1179			fi
1180
1181			_run_rc_precmd || return 1
1182
1183			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1184			_run_rc_doit "$_doit" || return 1
1185
1186			_run_rc_postcmd
1187			;;
1188
1189		restart)
1190					# prevent restart being called more
1191					# than once by any given script
1192					#
1193			if ${_rc_restart_done:-false}; then
1194				return 0
1195			fi
1196			_rc_restart_done=true
1197
1198			_run_rc_precmd || return 1
1199
1200			# run those in a subshell to keep global variables
1201			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1202			( run_rc_command ${_rc_prefix}start $rc_extra_args )
1203			_return=$?
1204			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1205
1206			_run_rc_postcmd
1207			;;
1208
1209		poll)
1210			_run_rc_precmd || return 1
1211			if [ -n "$rc_pid" ]; then
1212				wait_for_pids $rc_pid
1213			fi
1214			_run_rc_postcmd
1215			;;
1216
1217		rcvar)
1218			echo -n "# $name"
1219			if [ -n "$desc" ]; then
1220				echo " : $desc"
1221			else
1222				echo ""
1223			fi
1224			echo "#"
1225			# Get unique vars in $rcvar $rcvars
1226			for _v in $rcvar $rcvars; do
1227				case $v in
1228				$_v\ *|\ *$_v|*\ $_v\ *) ;;
1229				*)	v="${v# } $_v" ;;
1230				esac
1231			done
1232
1233			# Display variables.
1234			for _v in $v; do
1235				if [ -z "$_v" ]; then
1236					continue
1237				fi
1238
1239				eval _desc=\$${_v}_desc
1240				eval _defval=\$${_v}_defval
1241				_h="-"
1242
1243				eval echo \"$_v=\\\"\$$_v\\\"\"
1244				# decode multiple lines of _desc
1245				while [ -n "$_desc" ]; do
1246					case $_desc in
1247					*^^*)
1248						echo "# $_h ${_desc%%^^*}"
1249						_desc=${_desc#*^^}
1250						_h=" "
1251						;;
1252					*)
1253						echo "# $_h ${_desc}"
1254						break
1255						;;
1256					esac
1257				done
1258				echo "#   (default: \"$_defval\")"
1259			done
1260			echo ""
1261			;;
1262
1263		*)
1264			rc_usage $_keywords
1265			;;
1266
1267		esac
1268
1269		# Apply protect(1) to the PID if ${name}_oomprotect is set.
1270		case "$rc_arg" in
1271		start)
1272			# We cannot use protect(1) inside jails.
1273			if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1274			    [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1275				pid=$(check_process $command)
1276				case $_oomprotect in
1277				[Aa][Ll][Ll])
1278					${PROTECT} -i -p ${pid}
1279					;;
1280				[Yy][Ee][Ss])
1281					${PROTECT} -p ${pid}
1282					;;
1283				esac
1284			fi
1285		;;
1286		esac
1287
1288		return $_return
1289	done
1290
1291	echo 1>&2 "$0: unknown directive '$rc_arg'."
1292	rc_usage $_keywords
1293	# not reached
1294}
1295
1296#
1297# Helper functions for run_rc_command: common code.
1298# They use such global variables besides the exported rc_* ones:
1299#
1300#	name	       R/W
1301#	------------------
1302#	_precmd		R
1303#	_postcmd	R
1304#	_return		W
1305#
1306_run_rc_precmd()
1307{
1308	check_required_before "$rc_arg" || return 1
1309
1310	if [ -n "$_precmd" ]; then
1311		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1312		eval "$_precmd $rc_extra_args"
1313		_return=$?
1314
1315		# If precmd failed and force isn't set, request exit.
1316		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1317			return 1
1318		fi
1319	fi
1320
1321	check_required_after "$rc_arg" || return 1
1322
1323	return 0
1324}
1325
1326_run_rc_postcmd()
1327{
1328	if [ -n "$_postcmd" ]; then
1329		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1330		eval "$_postcmd $rc_extra_args"
1331		_return=$?
1332	fi
1333	return 0
1334}
1335
1336_run_rc_doit()
1337{
1338	debug "run_rc_command: doit: $*"
1339	eval "$@"
1340	_return=$?
1341
1342	# If command failed and force isn't set, request exit.
1343	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1344		return 1
1345	fi
1346
1347	return 0
1348}
1349
1350_run_rc_notrunning()
1351{
1352	local _pidmsg
1353
1354	if [ -n "$pidfile" ]; then
1355		_pidmsg=" (check $pidfile)."
1356	else
1357		_pidmsg=
1358	fi
1359	echo 1>&2 "${name} not running?${_pidmsg}"
1360}
1361
1362_run_rc_killcmd()
1363{
1364	local _cmd
1365
1366	_cmd="kill -$1 $rc_pid"
1367	if [ -n "$_user" ]; then
1368		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1369	fi
1370	echo "$_cmd"
1371}
1372
1373#
1374# run_rc_script file arg
1375#	Start the script `file' with `arg', and correctly handle the
1376#	return value from the script.
1377#	If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1378#	an old-style startup file.
1379#	If `file' ends with `.sh' and does not live in /etc/rc.d, it's sourced
1380#	into the current environment if $rc_fast_and_loose is set; otherwise
1381#	it is run as a child process.
1382#	If `file' appears to be a backup or scratch file, ignore it.
1383#	Otherwise if it is executable run as a child process.
1384#
1385run_rc_script()
1386{
1387	_file=$1
1388	_arg=$2
1389	if [ -z "$_file" -o -z "$_arg" ]; then
1390		err 3 'USAGE: run_rc_script file arg'
1391	fi
1392
1393	unset	name command command_args command_interpreter \
1394		extra_commands pidfile procname \
1395		rcvar rcvars rcvars_obsolete required_dirs required_files \
1396		required_vars
1397	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1398
1399	rc_service="$_file"
1400	case "$_file" in
1401	/etc/rc.d/*.sh)			# no longer allowed in the base
1402		warn "Ignoring old-style startup script $_file"
1403		;;
1404	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
1405		warn "Ignoring scratch file $_file"
1406		;;
1407	*)				# run in subshell
1408		if [ -x $_file ]; then
1409			if [ -n "$rc_fast_and_loose" ]; then
1410				set $_arg; . $_file
1411			else
1412				( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1413				  trap "echo Script $_file interrupted >&2 ; exit 1" 2
1414				  trap "echo Script $_file running >&2" 29
1415				  set $_arg; . $_file )
1416			fi
1417		fi
1418		;;
1419	esac
1420}
1421
1422#
1423# load_rc_config [service]
1424#	Source in the configuration file(s) for a given service.
1425#	If no service is specified, only the global configuration
1426#	file(s) will be loaded.
1427#
1428load_rc_config()
1429{
1430	local _name _rcvar_val _var _defval _v _msg _new _d
1431	_name=$1
1432
1433	if ${_rc_conf_loaded:-false}; then
1434		:
1435	else
1436		if [ -r /etc/defaults/rc.conf ]; then
1437			debug "Sourcing /etc/defaults/rc.conf"
1438			. /etc/defaults/rc.conf
1439			source_rc_confs
1440		elif [ -r /etc/rc.conf ]; then
1441			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1442			. /etc/rc.conf
1443		fi
1444		_rc_conf_loaded=true
1445	fi
1446
1447	# If a service name was specified, attempt to load
1448	# service-specific configuration
1449	if [ -n "$_name" ] ; then
1450		for _d in /etc ${local_startup}; do
1451			_d=${_d%/rc.d}
1452			if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1453				debug "Sourcing ${_d}/rc.conf.d/$_name"
1454				. ${_d}/rc.conf.d/"$_name"
1455			elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1456				local _rc
1457				for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1458					if [ -f "$_rc" ] ; then
1459						debug "Sourcing $_rc"
1460						. "$_rc"
1461					fi
1462				done
1463			fi
1464		done
1465	fi
1466
1467	# Set defaults if defined.
1468	for _var in $rcvar $rcvars; do
1469		eval _defval=\$${_var}_defval
1470		if [ -n "$_defval" ]; then
1471			eval : \${$_var:=\$${_var}_defval}
1472		fi
1473	done
1474
1475	# check obsolete rc.conf variables
1476	for _var in $rcvars_obsolete; do
1477		eval _v=\$$_var
1478		eval _msg=\$${_var}_obsolete_msg
1479		eval _new=\$${_var}_newvar
1480		case $_v in
1481		"")
1482			;;
1483		*)
1484			if [ -z "$_new" ]; then
1485				_msg="Ignored."
1486			else
1487				eval $_new=\"\$$_var\"
1488				if [ -z "$_msg" ]; then
1489					_msg="Use \$$_new instead."
1490				fi
1491			fi
1492			warn "\$$_var is obsolete.  $_msg"
1493			;;
1494		esac
1495	done
1496}
1497
1498#
1499# load_rc_config_var name var
1500#	Read the rc.conf(5) var for name and set in the
1501#	current shell, using load_rc_config in a subshell to prevent
1502#	unwanted side effects from other variable assignments.
1503#
1504load_rc_config_var()
1505{
1506	if [ $# -ne 2 ]; then
1507		err 3 'USAGE: load_rc_config_var name var'
1508	fi
1509	eval $(eval '(
1510		load_rc_config '$1' >/dev/null;
1511                if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1512			echo '$2'=\'\''${'$2'}\'\'';
1513		fi
1514	)' )
1515}
1516
1517#
1518# rc_usage commands
1519#	Print a usage string for $0, with `commands' being a list of
1520#	valid commands.
1521#
1522rc_usage()
1523{
1524	echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1525
1526	_sep=
1527	for _elem; do
1528		echo -n 1>&2 "$_sep$_elem"
1529		_sep="|"
1530	done
1531	echo 1>&2 ")"
1532	exit 1
1533}
1534
1535#
1536# err exitval message
1537#	Display message to stderr and log to the syslog, and exit with exitval.
1538#
1539err()
1540{
1541	exitval=$1
1542	shift
1543
1544	if [ -x /usr/bin/logger ]; then
1545		logger "$0: ERROR: $*"
1546	fi
1547	echo 1>&2 "$0: ERROR: $*"
1548	exit $exitval
1549}
1550
1551#
1552# warn message
1553#	Display message to stderr and log to the syslog.
1554#
1555warn()
1556{
1557	if [ -x /usr/bin/logger ]; then
1558		logger "$0: WARNING: $*"
1559	fi
1560	echo 1>&2 "$0: WARNING: $*"
1561}
1562
1563#
1564# info message
1565#	Display informational message to stdout and log to syslog.
1566#
1567info()
1568{
1569	case ${rc_info} in
1570	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1571		if [ -x /usr/bin/logger ]; then
1572			logger "$0: INFO: $*"
1573		fi
1574		echo "$0: INFO: $*"
1575		;;
1576	esac
1577}
1578
1579#
1580# debug message
1581#	If debugging is enabled in rc.conf output message to stderr.
1582#	BEWARE that you don't call any subroutine that itself calls this
1583#	function.
1584#
1585debug()
1586{
1587	case ${rc_debug} in
1588	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1589		if [ -x /usr/bin/logger ]; then
1590			logger "$0: DEBUG: $*"
1591		fi
1592		echo 1>&2 "$0: DEBUG: $*"
1593		;;
1594	esac
1595}
1596
1597#
1598# backup_file action file cur backup
1599#	Make a backup copy of `file' into `cur', and save the previous
1600#	version of `cur' as `backup'.
1601#
1602#	The `action' keyword can be one of the following:
1603#
1604#	add		`file' is now being backed up (and is possibly
1605#			being reentered into the backups system).  `cur'
1606#			is created.
1607#
1608#	update		`file' has changed and needs to be backed up.
1609#			If `cur' exists, it is copied to `back'
1610#			and then `file' is copied to `cur'.
1611#
1612#	remove		`file' is no longer being tracked by the backups
1613#			system.  `cur' is moved `back'.
1614#
1615#
1616backup_file()
1617{
1618	_action=$1
1619	_file=$2
1620	_cur=$3
1621	_back=$4
1622
1623	case $_action in
1624	add|update)
1625		if [ -f $_cur ]; then
1626			cp -p $_cur $_back
1627		fi
1628		cp -p $_file $_cur
1629		chown root:wheel $_cur
1630		;;
1631	remove)
1632		mv -f $_cur $_back
1633		;;
1634	esac
1635}
1636
1637# make_symlink src link
1638#	Make a symbolic link 'link' to src from basedir. If the
1639#	directory in which link is to be created does not exist
1640#	a warning will be displayed and an error will be returned.
1641#	Returns 0 on success, 1 otherwise.
1642#
1643make_symlink()
1644{
1645	local src link linkdir _me
1646	src="$1"
1647	link="$2"
1648	linkdir="`dirname $link`"
1649	_me="make_symlink()"
1650
1651	if [ -z "$src" -o -z "$link" ]; then
1652		warn "$_me: requires two arguments."
1653		return 1
1654	fi
1655	if [ ! -d "$linkdir" ]; then
1656		warn "$_me: the directory $linkdir does not exist."
1657		return 1
1658	fi
1659	if ! ln -sf $src $link; then
1660		warn "$_me: unable to make a symbolic link from $link to $src"
1661		return 1
1662	fi
1663	return 0
1664}
1665
1666# devfs_rulesets_from_file file
1667#	Reads a set of devfs commands from file, and creates
1668#	the specified rulesets with their rules. Returns non-zero
1669#	if there was an error.
1670#
1671devfs_rulesets_from_file()
1672{
1673	local file _err _me _opts
1674	file="$1"
1675	_me="devfs_rulesets_from_file"
1676	_err=0
1677
1678	if [ -z "$file" ]; then
1679		warn "$_me: you must specify a file"
1680		return 1
1681	fi
1682	if [ ! -e "$file" ]; then
1683		debug "$_me: no such file ($file)"
1684		return 0
1685	fi
1686
1687	# Disable globbing so that the rule patterns are not expanded
1688	# by accident with matching filesystem entries.
1689	_opts=$-; set -f
1690
1691	debug "reading rulesets from file ($file)"
1692	{ while read line
1693	do
1694		case $line in
1695		\#*)
1696			continue
1697			;;
1698		\[*\]*)
1699			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1700			if [ -z "$rulenum" ]; then
1701				warn "$_me: cannot extract rule number ($line)"
1702				_err=1
1703				break
1704			fi
1705			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1706			if [ -z "$rulename" ]; then
1707				warn "$_me: cannot extract rule name ($line)"
1708				_err=1
1709				break;
1710			fi
1711			eval $rulename=\$rulenum
1712			debug "found ruleset: $rulename=$rulenum"
1713			if ! /sbin/devfs rule -s $rulenum delset; then
1714				_err=1
1715				break
1716			fi
1717			;;
1718		*)
1719			rulecmd="${line%%"\#*"}"
1720			# evaluate the command incase it includes
1721			# other rules
1722			if [ -n "$rulecmd" ]; then
1723				debug "adding rule ($rulecmd)"
1724				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1725				then
1726					_err=1
1727					break
1728				fi
1729			fi
1730			;;
1731		esac
1732		if [ $_err -ne 0 ]; then
1733			debug "error in $_me"
1734			break
1735		fi
1736	done } < $file
1737	case $_opts in *f*) ;; *) set +f ;; esac
1738	return $_err
1739}
1740
1741# devfs_init_rulesets
1742#	Initializes rulesets from configuration files. Returns
1743#	non-zero if there was an error.
1744#
1745devfs_init_rulesets()
1746{
1747	local file _me
1748	_me="devfs_init_rulesets"
1749
1750	# Go through this only once
1751	if [ -n "$devfs_rulesets_init" ]; then
1752		debug "$_me: devfs rulesets already initialized"
1753		return
1754	fi
1755	for file in $devfs_rulesets; do
1756		if ! devfs_rulesets_from_file $file; then
1757			warn "$_me: could not read rules from $file"
1758			return 1
1759		fi
1760	done
1761	devfs_rulesets_init=1
1762	debug "$_me: devfs rulesets initialized"
1763	return 0
1764}
1765
1766# devfs_set_ruleset ruleset [dir]
1767#	Sets the default ruleset of dir to ruleset. The ruleset argument
1768#	must be a ruleset name as specified in devfs.rules(5) file.
1769#	Returns non-zero if it could not set it successfully.
1770#
1771devfs_set_ruleset()
1772{
1773	local devdir rs _me
1774	[ -n "$1" ] && eval rs=\$$1 || rs=
1775	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1776	_me="devfs_set_ruleset"
1777
1778	if [ -z "$rs" ]; then
1779		warn "$_me: you must specify a ruleset number"
1780		return 1
1781	fi
1782	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1783	if ! /sbin/devfs $devdir ruleset $rs; then
1784		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1785		return 1
1786	fi
1787	return 0
1788}
1789
1790# devfs_apply_ruleset ruleset [dir]
1791#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1792#	The ruleset argument must be a ruleset name as specified
1793#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1794#	if it could not apply the ruleset.
1795#
1796devfs_apply_ruleset()
1797{
1798	local devdir rs _me
1799	[ -n "$1" ] && eval rs=\$$1 || rs=
1800	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1801	_me="devfs_apply_ruleset"
1802
1803	if [ -z "$rs" ]; then
1804		warn "$_me: you must specify a ruleset"
1805		return 1
1806	fi
1807	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1808	if ! /sbin/devfs $devdir rule -s $rs applyset; then
1809		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1810		return 1
1811	fi
1812	return 0
1813}
1814
1815# devfs_domount dir [ruleset]
1816#	Mount devfs on dir. If ruleset is specified it is set
1817#	on the mount-point. It must also be a ruleset name as specified
1818#	in a devfs.rules(5) file. Returns 0 on success.
1819#
1820devfs_domount()
1821{
1822	local devdir rs _me
1823	devdir="$1"
1824	[ -n "$2" ] && rs=$2 || rs=
1825	_me="devfs_domount()"
1826
1827	if [ -z "$devdir" ]; then
1828		warn "$_me: you must specify a mount-point"
1829		return 1
1830	fi
1831	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1832	if ! mount -t devfs dev "$devdir"; then
1833		warn "$_me: Unable to mount devfs on $devdir"
1834		return 1
1835	fi
1836	if [ -n "$rs" ]; then
1837		devfs_init_rulesets
1838		devfs_set_ruleset $rs $devdir
1839		devfs -m $devdir rule applyset
1840	fi
1841	return 0
1842}
1843
1844# Provide a function for normalizing the mounting of memory
1845# filesystems.  This should allow the rest of the code here to remain
1846# as close as possible between 5-current and 4-stable.
1847#   $1 = size
1848#   $2 = mount point
1849#   $3 = (optional) extra mdmfs flags
1850mount_md()
1851{
1852	if [ -n "$3" ]; then
1853		flags="$3"
1854	fi
1855	/sbin/mdmfs $flags -s $1 ${mfs_type} $2
1856}
1857
1858# Code common to scripts that need to load a kernel module
1859# if it isn't in the kernel yet. Syntax:
1860#   load_kld [-e regex] [-m module] file
1861# where -e or -m chooses the way to check if the module
1862# is already loaded:
1863#   regex is egrep'd in the output from `kldstat -v',
1864#   module is passed to `kldstat -m'.
1865# The default way is as though `-m file' were specified.
1866load_kld()
1867{
1868	local _loaded _mod _opt _re
1869
1870	while getopts "e:m:" _opt; do
1871		case "$_opt" in
1872		e) _re="$OPTARG" ;;
1873		m) _mod="$OPTARG" ;;
1874		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1875		esac
1876	done
1877	shift $(($OPTIND - 1))
1878	if [ $# -ne 1 ]; then
1879		err 3 'USAGE: load_kld [-e regex] [-m module] file'
1880	fi
1881	_mod=${_mod:-$1}
1882	_loaded=false
1883	if [ -n "$_re" ]; then
1884		if kldstat -v | egrep -q -e "$_re"; then
1885			_loaded=true
1886		fi
1887	else
1888		if kldstat -q -m "$_mod"; then
1889			_loaded=true
1890		fi
1891	fi
1892	if ! $_loaded; then
1893		if ! kldload "$1"; then
1894			warn "Unable to load kernel module $1"
1895			return 1
1896		else
1897			info "$1 kernel module loaded."
1898		fi
1899	else
1900		debug "load_kld: $1 kernel module already loaded."
1901	fi
1902	return 0
1903}
1904
1905# ltr str src dst [var]
1906#	Change every $src in $str to $dst.
1907#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1908#	awk(1). If var is non-NULL, set it to the result.
1909ltr()
1910{
1911	local _str _src _dst _out _com _var
1912	_str="$1"
1913	_src="$2"
1914	_dst="$3"
1915	_var="$4"
1916	_out=""
1917
1918	local IFS="${_src}"
1919	for _com in ${_str}; do
1920		if [ -z "${_out}" ]; then
1921			_out="${_com}"
1922		else
1923			_out="${_out}${_dst}${_com}"
1924		fi
1925	done
1926	if [ -n "${_var}" ]; then
1927		setvar "${_var}" "${_out}"
1928	else
1929		echo "${_out}"
1930	fi
1931}
1932
1933# Creates a list of providers for GELI encryption.
1934geli_make_list()
1935{
1936	local devices devices2
1937	local provider mountpoint type options rest
1938
1939	# Create list of GELI providers from fstab.
1940	while read provider mountpoint type options rest ; do
1941		case ":${options}" in
1942		:*noauto*)
1943			noauto=yes
1944			;;
1945		*)
1946			noauto=no
1947			;;
1948		esac
1949
1950		case ":${provider}" in
1951		:#*)
1952			continue
1953			;;
1954		*.eli)
1955			# Skip swap devices.
1956			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1957				continue
1958			fi
1959			devices="${devices} ${provider}"
1960			;;
1961		esac
1962	done < /etc/fstab
1963
1964	# Append providers from geli_devices.
1965	devices="${devices} ${geli_devices}"
1966
1967	for provider in ${devices}; do
1968		provider=${provider%.eli}
1969		provider=${provider#/dev/}
1970		devices2="${devices2} ${provider}"
1971	done
1972
1973	echo ${devices2}
1974}
1975
1976# Originally, root mount hold had to be released before mounting
1977# the root filesystem.  This delayed the boot, so it was changed
1978# to only wait if the root device isn't readily available.  This
1979# can result in rc scripts executing before all the devices - such
1980# as graid(8), or USB disks - can be accessed.  This function can
1981# be used to explicitly wait for root mount holds to be released.
1982root_hold_wait()
1983{
1984	local wait waited holders
1985
1986	waited=0
1987	while true; do
1988		holders="$(sysctl -n vfs.root_mount_hold)"
1989		if [ -z "${holders}" ]; then
1990			break;
1991		fi
1992		if [ ${waited} -eq 0 ]; then
1993			echo -n "Waiting ${root_hold_delay}s" \
1994			"for the root mount holders: ${holders}"
1995		else
1996			echo -n .
1997		fi
1998		if [ ${waited} -ge ${root_hold_delay} ]; then
1999			echo
2000			break
2001		fi
2002		sleep 1
2003		waited=$(($waited + 1))
2004	done
2005}
2006
2007# Find scripts in local_startup directories that use the old syntax
2008#
2009find_local_scripts_old() {
2010	zlist=''
2011	slist=''
2012	for dir in ${local_startup}; do
2013		if [ -d "${dir}" ]; then
2014			for file in ${dir}/[0-9]*.sh; do
2015				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2016				    continue
2017				zlist="$zlist $file"
2018			done
2019			for file in ${dir}/[!0-9]*.sh; do
2020				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
2021				    continue
2022				slist="$slist $file"
2023			done
2024		fi
2025	done
2026}
2027
2028find_local_scripts_new() {
2029	local_rc=''
2030	for dir in ${local_startup}; do
2031		if [ -d "${dir}" ]; then
2032			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
2033				case "$file" in
2034				*.sample) ;;
2035				*)	if [ -x "$file" ]; then
2036						local_rc="${local_rc} ${file}"
2037					fi
2038					;;
2039				esac
2040			done
2041		fi
2042	done
2043}
2044
2045# check_required_{before|after} command
2046#	Check for things required by the command before and after its precmd,
2047#	respectively.  The two separate functions are needed because some
2048#	conditions should prevent precmd from being run while other things
2049#	depend on precmd having already been run.
2050#
2051check_required_before()
2052{
2053	local _f
2054
2055	case "$1" in
2056	start)
2057		for _f in $required_vars; do
2058			if ! checkyesno $_f; then
2059				warn "\$${_f} is not enabled."
2060				if [ -z "$rc_force" ]; then
2061					return 1
2062				fi
2063			fi
2064		done
2065
2066		for _f in $required_dirs; do
2067			if [ ! -d "${_f}/." ]; then
2068				warn "${_f} is not a directory."
2069				if [ -z "$rc_force" ]; then
2070					return 1
2071				fi
2072			fi
2073		done
2074
2075		for _f in $required_files; do
2076			if [ ! -r "${_f}" ]; then
2077				warn "${_f} is not readable."
2078				if [ -z "$rc_force" ]; then
2079					return 1
2080				fi
2081			fi
2082		done
2083		;;
2084	esac
2085
2086	return 0
2087}
2088
2089check_required_after()
2090{
2091	local _f _args
2092
2093	case "$1" in
2094	start)
2095		for _f in $required_modules; do
2096			case "${_f}" in
2097				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
2098				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
2099				*)	_args="${_f}" ;;
2100			esac
2101			if ! load_kld ${_args}; then
2102				if [ -z "$rc_force" ]; then
2103					return 1
2104				fi
2105			fi
2106		done
2107		;;
2108	esac
2109
2110	return 0
2111}
2112
2113# check_jail mib
2114#	Return true if security.jail.$mib exists and set to 1.
2115
2116check_jail()
2117{
2118	local _mib _v
2119
2120	_mib=$1
2121	if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2122		case $_v in
2123		1)	return 0;;
2124		esac
2125	fi
2126	return 1
2127}
2128
2129# check_kern_features mib
2130#	Return existence of kern.features.* sysctl MIB as true or
2131#	false.  The result will be cached in $_rc_cache_kern_features_
2132#	namespace.  "0" means the kern.features.X exists.
2133
2134check_kern_features()
2135{
2136	local _v
2137
2138	[ -n "$1" ] || return 1;
2139	eval _v=\$_rc_cache_kern_features_$1
2140	[ -n "$_v" ] && return "$_v";
2141
2142	if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2143		eval _rc_cache_kern_features_$1=0
2144		return 0
2145	else
2146		eval _rc_cache_kern_features_$1=1
2147		return 1
2148	fi
2149}
2150
2151# check_namevarlist var
2152#	Return "0" if ${name}_var is reserved in rc.subr.
2153
2154_rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend"
2155check_namevarlist()
2156{
2157	local _v
2158
2159	for _v in $_rc_namevarlist; do
2160	case $1 in
2161	$_v)	return 0 ;;
2162	esac
2163	done
2164
2165	return 1
2166}
2167
2168# _echoonce var msg mode
2169#	mode=0: Echo $msg if ${$var} is empty.
2170#	        After doing echo, a string is set to ${$var}.
2171#
2172#	mode=1: Echo $msg if ${$var} is a string with non-zero length.
2173#
2174_echoonce()
2175{
2176	local _var _msg _mode
2177	eval _var=\$$1
2178	_msg=$2
2179	_mode=$3
2180
2181	case $_mode in
2182	1)	[ -n "$_var" ] && echo "$_msg" ;;
2183	*)	[ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2184	esac
2185}
2186
2187# If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2188# still override this, but /etc/defaults/rc.conf can't unconditionally set this
2189# since it would undo what we've done here.
2190if kenv -q rc.debug > /dev/null ; then
2191	rc_debug=YES
2192fi
2193